#include <SPI.h>
#include <Adb.h>
#include <Servo.h>

#define SERV_PIN 2

// Hardware servos
Servo servos;

// Adb connection.
Connection * connection;

// Elapsed time for ADC sampling
long lastTime;

// servo data
int sv_data;

// Event handler for the shell connection. 
void adbEventHandler(Connection * connection, adb_eventType event, uint16_t length, uint8_t * data)
{
  int i;
  static uint8_t befor_data; 

  // Data packets contain two bytes, one for each servo, in the range of [0..180]
  if (event == ADB_CONNECTION_RECEIVE)
  {
    if ((millis() - lastTime) > 100)
    {
      Serial.println(data[0], DEC);
      Serial.println(befor_data, DEC);
      if( befor_data != data[0] ) {
        Serial.println("change!");
        sv_data = (int)data[0];
        befor_data = data[0];
      }
    }
  }

}

void setup()
{

  // Initialise serial port
  Serial.begin(57600);
  
  // Note start time
  lastTime = millis();
  
  // Attach servos
  servos.attach(SERV_PIN, 680, 2400);

  // Initialise the ADB subsystem.  
  ADB::init();

  // Open an ADB stream to the phone's shell. Auto-reconnect
  connection = ADB::addConnection("tcp:4567", true, adbEventHandler);  
}

void loop()
{
  
  static int befor_data;
  
  if( befor_data != sv_data )
  {
    befor_data = sv_data;
    servos.write(sv_data);
  }

  // Poll the ADB subsystem.
  ADB::poll();
}

